import Resource from "./resource";
import { Container } from "starspot-core";
export interface CallbackTarget {
    invokeCallback(name: string, ...args: any[]): Promise<void>;
}
export interface OperationOptions {
    [key: string]: any;
    container?: Container;
    target?: CallbackTarget;
}
export interface ResourceFactory {
    new (): Resource<any>;
}
declare abstract class Operation {
    constructor(options: OperationOptions);
    container: Container;
    target: CallbackTarget;
    type: string;
    resource?: Resource<any>;
    resources?: Resource<any>;
    abstract process(): Promise<any>;
    protected findResource(): ResourceFactory & typeof Resource;
}
export default Operation;
