import { DescriptorMap, Descriptor } from "starspot-metadata";
/**
 * Retrieves the Field descriptor for the named attribute, creating a new
 * descriptor if none already exists.
 */
export declare function fieldFor<T extends Field>(target: any, key: string, FieldClass: {
    new (...args: any[]): T;
}): T;
export declare function fieldsFor(target: any): Fields;
export declare function setFieldsFor(target: any, fields: Fields): void;
export declare function mergeFields(target: any, targetConstructor: any): [Fields, string[], string[]];
export declare type Fields = DescriptorMap<string, Field>;
export declare class Field implements Descriptor {
    name: string;
    constructor(name: string);
    updatable: boolean;
    creatable: boolean;
    ignoreUpdateErrors: boolean;
    writable: boolean;
    clone(): this;
}
export declare class AttributeField extends Field {
}
export declare type RelationshipType = "hasOne" | "hasMany";
export declare class RelationshipField extends Field {
    type: RelationshipType;
}
