import { Container } from "starspot-core";
import JSONAPI from "./json-api";
import Resource from "./resource";
import { Result, ResourceResult, ResourcesResult } from "./results";
declare class Serializer {
    isCollection: boolean;
    includedResources: Resource<any>[];
    primaryResources: Resource<any>[];
    container: Container;
    serializeResults(results: Result[]): Promise<{
        json: JSONAPI.DataDocument;
        statusCode: number;
    }>;
    processResults(results: Result[]): void;
    processResource(result: ResourceResult): void;
    processResources(result: ResourcesResult): void;
    serialize(model: any, included?: Included): Promise<JSONAPI.DataDocument>;
    serializeMany(models: any[], included?: Included): Promise<JSONAPI.DataDocument>;
}
export declare class Included {
    seen: Map<string, Map<string, any>>;
    toInclude: any[];
    getIncluded(): any[];
    add(model: any): void;
    reset(): void;
}
export default Serializer;
